'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
function createDOMNode(vdom) {
  var doc = arguments.length <= 1 || arguments[1] === undefined ? document : arguments[1];

  if (typeof vdom === 'string') {
    return doc.createTextNode(vdom);
  }
  var type = vdom.type;
  var props = vdom.props;

  var node = doc.createElement(type);
  for (var name in props) {
    if (props.hasOwnProperty(name)) {
      node.setAttribute(name, props[name]);
    }
  }
  if (vdom.children) {
    vdom.children.forEach(function (c) {
      var child = createDOMNode(c, doc);
      node.appendChild(child);
    });
  }
  return node;
}

exports["default"] = createDOMNode;
module.exports = exports['default'];