'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _ChildOperationTypes = require('./ChildOperationTypes');

function patch(_ref, _ref2) {
  var removeQueue = _ref.removeQueue;
  var insertQueue = _ref.insertQueue;
  var updateQueue = _ref.updateQueue;
  var processNew = _ref2.processNew;
  var processUpdate = _ref2.processUpdate;
  var processMove = _ref2.processMove;
  var processRemove = _ref2.processRemove;

  updateQueue.forEach(function (q) {
    processUpdate(q);
  });

  var moves = {};

  removeQueue.forEach(function (q) {
    var ret = processRemove(q);
    if (q.type === _ChildOperationTypes.MOVE) {
      moves[q.toPath.join(',')] = ret;
    }
  });

  insertQueue.forEach(function (q) {
    if (q.type === _ChildOperationTypes.NEW) {
      processNew(q);
    } else if (q.type === _ChildOperationTypes.MOVE) {
      processMove(q, moves[q.toPath.join(',')]);
    }
  });
}

exports["default"] = patch;
module.exports = exports['default'];